// Xg12.8@؂̃tN^
package graphics;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class Tree extends JPanel{
   double scale = 0.7;        // }̒̔䗦
   int angle = 30;           // }̍LpxixPʁj
   int N = 8;               // JԂ
   final int W = 400, H = 400;
   double len = 100.0;    // ŏ̎}̒
   BufferedImage bi;
   Graphics bg;
   Tree() {
      setPreferredSize(new Dimension(W, H)); 
      bi = new BufferedImage(W, H, BufferedImage.TYPE_INT_RGB);
      bg = bi.createGraphics();
      bg.setColor(Color.white);  
      bg.fillRect(0,0,W,H); 
      bg.setColor(new Color(100, 153, 0));  // `F̐ݒ
      drawTree(W/2, H, len, 0, N);  // ċÅJn 
   }
   void drawTree(double x1, double y1, double len, double stand, int n){
      double x2=x1 + len*Math.sin(Math.toRadians(stand));  //}xW
      double y2=y1 - len*Math.cos(Math.toRadians(stand));  //}yW
      bg.drawLine((int)x1,(int)y1,(int)x2,(int)y2); //`
      if(n>=1){   //؂̖[܂ŒBĂȂƂ́C̎}`
	 drawTree(x2,y2,len*scale,stand-angle,n-1); //̉E̎}`
	 drawTree(x2,y2,len*scale,stand+angle,n-1); //̍̎}`
      }
   }
   protected void paintComponent(Graphics g){
      super.paintComponent(g); 
      g.drawImage(bi, 0, 0, this);
   }
   public static void main(String args[]){
      JFrame frame = new JFrame();
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      Tree h = new Tree();
      frame.add(h, BorderLayout.CENTER);
      frame.pack();               
      frame.setVisible(true);
    }
}

